package geograph.test;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import android.app.Activity;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.widget.TextView;


/**
 * 
 * @author fcamps
 *
 *  Créer une activité de type MAP ACTIVITY et utiliser ce code pour 
 *  afficher l'adresse courante en fonction de la position (lat, long),
 *  voir TD4_4
 */
public class GeoActivity extends Activity
{	
	double LATITUDE = 43.5634;
	double LONGITUDE = 1.4778;
	
    /** Appel de l'activite */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        TextView myLatitude = (TextView)findViewById(R.id.mylatitude);
        TextView myLongitude = (TextView)findViewById(R.id.mylongitude);
        TextView myAddress = (TextView)findViewById(R.id.myaddress);
        
        myLatitude.setText("Latitude: " + String.valueOf(LATITUDE));
        myLongitude.setText("Longitude: " + String.valueOf(LONGITUDE));
        
        // reverse geocoder
        Geocoder geocoder = new Geocoder(this, Locale.ENGLISH);

        try {
			List<Address> addresses = geocoder.getFromLocation(LATITUDE, LONGITUDE, 1);
			
			if(addresses != null)
			{
				Address returnedAddress = addresses.get(0);
				StringBuilder strReturnedAddress = new StringBuilder("Address:\n");
				
				for(int i=0; i<returnedAddress.getMaxAddressLineIndex(); i++) 
				{
					strReturnedAddress.append(returnedAddress.getAddressLine(i)).append("\n");
				}
				myAddress.setText(strReturnedAddress.toString());
			}
			else
			{
				myAddress.setText("No Address returned!");
			}
		} 
        catch (IOException e)
        {
			e.printStackTrace();
			myAddress.setText("Canont get Address!");
		}
    }
}