package android.exemple.bindlocal;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.exemple.R;
import android.os.Bundle;
import android.os.IBinder;
import android.view.View;
import android.widget.Button;

/**
 * <h4>COnnexion a un service locale et utilisation des methodes</h4>
 * 
 * @author fcamps
 *
 */
public class GestionServiceActivite extends Activity 
{

	private MonService mMonService;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// Associe le service à cette activité
		Intent intentAssociation = new Intent(this, MonService.class);

		if (bindService(intentAssociation, mConnexion, Context.BIND_AUTO_CREATE))
		{
			// Si l'association a lieu, nous affectons une action du service à
			// notre bouton.
			Button btnService = (Button) findViewById(R.id.BoutonService);

			btnService.setOnClickListener(new View.OnClickListener()
			{
				public void onClick(View v)
				{
					mMonService.AfficheStatut();
				}
			});
		}
	}

	/**
	 * 
	 */
	private ServiceConnection mConnexion = new ServiceConnection() 
	{

		// Méthode appelée lorsque la connexion est établie. Récupère la référence
		// vers le service associé.
		public void onServiceConnected(ComponentName className, IBinder service)
		{
			mMonService = ((MonService.MonServiceBinder) service).getService();
		}

		// Méthode appelée lorsque la connexion est rompue
		public void onServiceDisconnected(ComponentName className)
		{
			mMonService = null;
		}
	};

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		unbindService(mConnexion);
	}
}