/**
 * 
 */
package example.TD1;


import android.app.Activity;
import android.content.res.Configuration;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

/**
 *<h4> Recuperation de l'etat de l'activite</h4>
 *
 *Ce programme presente une structure Activity complete avec la recuperation des etats en cas de redemarrage
 *de l'application.<br><br>
 * 
 * TODO :
 * 1) Analyser le code et faite un run, regarder attentivement les log dans le logcat pour verifier
 * les differents etats. (faire une rotation de l'equipement pour redemarrer l'activity).
 * 2) Sauvegarder une donnee (String, boolean ...)  dans le bundle. Attention la comportement dans l'emulateur
 * peut etre different<br><br>
 * 
 * Voir aussi :<br>
 * 
 * http://developer.android.com/reference/android/util/Log.html<br>
 * 
 * http://developer.android.com/guide/topics/manifest/manifest-intro.html<br>
 * 
 * http://developer.android.com/reference/android/app/Activity.html<br>
 * 
 * @author fcamps@laas.fr
 *
 */
public class TD0_0_1 extends Activity {

	private static final String TAG = "ActivityObs";


	/** Pour sauvegarder l'etat des variables on utilise des containers :
	 *  putString
	 *  putBoolean
	 *  putChar
	 *  putFloat
	 *  ...
	 *  
	 *  que l'on place directement dans le Bundle, le Bundle est ensuite
	 *  rappeler a la creation de l'activite
	 * 
	 */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		Log.v(TAG, "onCreate()");
		
		if( savedInstanceState != null ) {
			// L'application est rechargee ici avec le contenu du bundle
			// faire une rotation de votre equipement pour visualiser la sauvegarde
			// puis la restauration
			// !! on peut aussi surcharger onRestoreInstanceState() pour realiser
			// ce travail

			savedInstanceState.

			Log.v(TAG, "onCreate --> Bundle restore");
		}
	}

	@Override
	protected void onRestart()
	{
		super.onRestart();
		Log.v(TAG, "onRestart()");
	}

	@Override
	protected void onResume() 
	{
		super.onResume();
		Log.v(TAG, "onResume()");
	}


	@Override
	protected void onPause() {
		super.onPause();
		Log.v(TAG, "onPause()");
	}

	@Override
	protected void onStop()
	{
		super.onStart();
		Log.v(TAG, "onStop()");
	}

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.v(TAG, "onDestroy()");

	}

	/** Sauvegarde des etats en cas de suppression de l'activite par le systeme ou rotation
	 * de l'equipement
	 * 
	 */
	@Override
	protected void onSaveInstanceState(Bundle outState) 
	{
		super.onSaveInstanceState(outState);

		Log.v(TAG, "onSaveInstanceState(Bundle outState)");

		outState.putString("message", "This is my message to be reloaded");
	}

	@Override
	protected void onRestoreInstanceState (Bundle savedInstanceState)
	{
		super.onRestoreInstanceState (savedInstanceState);
		Log.v(TAG, "onRestoreInstanceState (Bundle savedInstanceState)");
		
		 setContentView(R.layout.main);
		
		if( savedInstanceState != null ) {
			// L'application est rechargee ici avec le contenu du bundle
			Toast.makeText(this, savedInstanceState .getString("message"), Toast.LENGTH_LONG).show();
		}
	}
	/**
	 * Cette méthode est appelée en fonction du SDK voir : 
	 * 
	 * http://developer.android.com/guide/topics/resources/runtime-changes.html
	 */
	@Override
	public void onConfigurationChanged(Configuration newConfig) {
	  super.onConfigurationChanged(newConfig);	
	  
	  Log.v(TAG, "onConfigurationChanged()");
	  
	}

}
