package exemple.android;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
 
/**
 * <h4>Activite lance a partir de Activity1</h4>
 * 
 * Ce programmme propose ensuite de lancer une recherche sur Google via un web service.
 * 
 * @author fcamps
 *
 * Dans ce TD :<br>
 *  - lancer une sous activité<br>
 *  - logger des infos<br>
 *  - passer des infos entre activité<br>
 *
 */
public class Activity2 extends Activity implements View.OnClickListener
{
 
	private Button mImageButton;
	private EditText mEditText;
	private static final String myTAG = "MyApp";
 
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.google);
		
		// IHM
		mImageButton = (Button)findViewById(R.id.button2);
		mEditText = (EditText)findViewById(R.id.editText1);
		
		//event
		mImageButton.setOnClickListener(this);
		
		Bundle extras = getIntent().getExtras();
		
		// Information de l'activite 1
		String info = extras.getString("example.android.Activity1");
		
		// Log 		
		Log.i(myTAG, info);
	}
 
	@Override
	public void onClick(View view)
	{
		if (view == mImageButton) 
		{
			final String requete = "http://www.google.fr/search?q=" + mEditText.getText();
			Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(requete));
			startActivity(intent);
		}
	}
}