package exemple.android.thread;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.widget.TextView;
import exemple.android.R;

/**
 * <h4>IHM en attente d'un calcul</h4>
 * 
 * Ce programme presente une IHM en attente d'un calcul long.
 * 
 * @author fcamps
 *
 */
public class ProgressDialogExample extends Activity implements Runnable
{

	private String pi_string;
	private TextView tv;
	private ProgressDialog progressdiag;

	@Override
	public void onCreate(Bundle icicle)
	{
		super.onCreate(icicle);
		setContentView(R.layout.handler);

		tv = (TextView) this.findViewById(R.id.textThread);
		tv.setText("Press any key to start calculation");
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) 
	{
		if(keyCode == event.KEYCODE_BACK)
			 finish();

		progressdiag = ProgressDialog.show(this, "Working..", "Calculating Pi", true,
				false);

		Thread thread = new Thread(this);
		thread.start();

		return super.onKeyDown(keyCode, event);
	}

	/**
	 * 
	 */
	public void run() 
	{
		// Lancement d'un calcul
		pi_string = Pi.computePi(800).toString();
		
		// Le calcul est fini, on arrete la progress bar en envoyant
		// un message
		handler.sendEmptyMessage(0);
	}

	/**
	 * 
	 */
	private Handler handler = new Handler() 
	{
		@Override
		public void handleMessage(Message msg) 
		{
			// stop de la progress bar
			progressdiag.dismiss();
			
			// Affichage de PI
			tv.setText(pi_string);
		}
	};
	
	@Override
	protected void onDestroy()
	{
		android.os.Process.killProcess(android.os.Process.myPid());
		super.onDestroy();
	}

}