package android.provider.diary;


import android.content.ContentProvider;
import android.content.ContentValues;
import android.content.UriMatcher;
import android.database.Cursor;
import android.net.Uri;

import com.android.data.Constants;
import com.android.data.MyDB;

/**
 * 
 * @author fcamps
 *dba
 * Provider of diary data
 */
public class DiaryContentProvider extends ContentProvider
{
	private MyDB dba;
	private static final  UriMatcher sUriMatcher;
	private static final int DIARIES=1; //the code that is returned when a URI is matched against the given components. Must be positive.
	public  static final  String AUTHORITY = "android.provider.diary";

	private static final String uriDiary = "content://" + AUTHORITY + "/diaries";
	public static final Uri CONTENT_URI = Uri.parse(uriDiary);

	public static final int COLONNE_ID = 0;
	public static final int COLONNE_TITLE_NAME = 1;
	public static final int COLONNE_CONTENT_NAME = 2;
	public static final int COLONNE_DATE_NAME = 3;
		
		
	// insert the path of the data provider
	static
	{
		sUriMatcher = new UriMatcher(UriMatcher.NO_MATCH);
		sUriMatcher.addURI(AUTHORITY, Constants.TABLE_NAME, DIARIES);
		sUriMatcher.addURI(AUTHORITY, Constants.KEY_ID, COLONNE_ID);
	}

	@Override
	public int delete(Uri uri, String selection, String[] selectionArgs) 
	{
		// TODO Auto-generated method stub
		return 0;
	}

		
	@Override
	public String getType(Uri uri)
	{
		switch (sUriMatcher.match(uri)) 
		{
		case COLONNE_ID:
			return "android.provider.diary";
		case DIARIES:
			return "android.provider.diary";
		default:
			throw new IllegalArgumentException("URI non supporté : " + uri);
		}
	}
	
	

	@Override
	public Uri insert(Uri uri, ContentValues values)
	{
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean onCreate()
	{
		// TODO Auto-generated method stub
		dba = new MyDB(this.getContext());
		dba.open();
		return false;
	}

	@Override
	public Cursor query(Uri uri, String[] projection, String selection,
			String[] selectionArgs, String sortOrder) 
	{
		// TODO Auto-generated method stub

		Cursor c=null;

		switch (sUriMatcher.match(uri)) 
		{
		case DIARIES:
			c = dba.getdiaries();
			break;

		default:
			throw new IllegalArgumentException("Uri non supportée : " + uri);
		}

		c.setNotificationUri(getContext().getContentResolver(), uri);
		return c;
	}


	@Override
	public int update(Uri uri, ContentValues values, String selection,
			String[] selectionArgs) 
	{
		// TODO Auto-generated method stub
		return 0;
	}

}
