package android.provider.diary;

import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Date;

import android.app.ListActivity;
import android.content.Context;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.android.data.Constants;
import com.android.data.MyDB;

import datastorage.gen.R;
/**
 * 
 * @author fcamps
 *
 * Activite qui affiche le contenu de l'agenda
 * 
 * 
 */
public class DisplayDiaries extends ListActivity
{

	MyDB dba;
	DiaryAdapter myAdapter;

	private static final String TAG = "ActivityDisplayDiary";

	/**
	 * 
	 * @author fcamps
	 *
	 */
	private class MyDiary
	{
		public String title;
		public String content;
		public String recorddate;
		/**
		 * 
		 * @param t
		 * @param c
		 * @param r
		 */
		public MyDiary(String t, String c, String r)
		{
			title=t;
			content=c;
			recorddate=r;
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		// TODO Auto-generated method stub
		dba = new MyDB(this);
		dba.open();
		setContentView(R.layout.diaries);

		super.onCreate(savedInstanceState);
		myAdapter = new DiaryAdapter(this);
		this.setListAdapter(myAdapter);
	}

	/**
	 * 
	 * @author fcamps
	 *
	 */
	private class DiaryAdapter extends BaseAdapter
	{
		private LayoutInflater mInflater;
		private ArrayList<MyDiary> diaries;

		public DiaryAdapter(Context context) 
		{
			mInflater = LayoutInflater.from(context);
			diaries = new ArrayList<MyDiary>();
			getdata();
		}

		/**
		 * 
		 */
		public void getdata()
		{
			Cursor c = dba.getdiaries();
			startManagingCursor(c);

			if(c.moveToFirst())
			{
				do
				{
					String title = c.getString(c.getColumnIndex(Constants.TITLE_NAME));
					String content = c.getString(c.getColumnIndex(Constants.CONTENT_NAME));
					DateFormat dateFormat = DateFormat.getDateTimeInstance();
					String datedata = dateFormat.format(new Date(c.getLong(c.getColumnIndex(Constants.DATE_NAME))).getTime());
					MyDiary temp = new MyDiary(title,content,datedata);
					diaries.add(temp);

				}while(c.moveToNext());

			}

			// c.deactivate();
			//   c.close();

		}

		@Override
		public int getCount()
		{
			// TODO Auto-generated method stub
			return diaries.size();
		}

		@Override
		public MyDiary getItem(int i) 
		{
			// TODO Auto-generated method stub
			return diaries.get(i);
		}

		@Override
		public long getItemId(int i) 
		{
			// TODO Auto-generated method stub
			return i;
		}

		@Override
		public View getView(int arg0, View arg1, ViewGroup arg2)
		{
			final ViewHolder holder;
			View v = arg1;

			if ((v == null) || (v.getTag() == null))
			{
				v = mInflater.inflate(R.layout.diaryrow, null);
				holder = new ViewHolder();
				holder.mTitle = (TextView)v.findViewById(R.id.name);
				holder.mDate = (TextView)v.findViewById(R.id.datetext);
				v.setTag(holder);
			} 
			else 
			{
				holder = (ViewHolder) v.getTag();
			}  

			holder.mdiary = getItem(arg0);
			holder.mTitle.setText(holder.mdiary.title);
			holder.mDate.setText(holder.mdiary.recorddate);

			v.setTag(holder);

			// TODO Auto-generated method stub
			return v;
		}

		/**
		 * 
		 * @author fcamps
		 *
		 */
		public class ViewHolder
		{
			MyDiary mdiary;
			TextView mTitle;
			TextView mDate;
		}

	}

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.v(TAG, "onDestroy()");

		dba.close();
		finish();
	}


}
