package android.exemple.bindlocal;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.exemple.R;
import android.os.Bundle;
import android.os.IBinder;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

/**
 * <h4>Connexion a un service locale et utilisation des methodes</h4>
 * 
 * @author fcamps
 *
 */

    public class BindingActivity extends Activity {

    MonService mService;
    boolean mBound = false;

    Button b1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);


        b1 = (Button) findViewById(R.id.BoutonService);
        b1.setOnClickListener(myhandler1);

        Toast.makeText(this, "********* ", Toast.LENGTH_LONG).show();

    }


    View.OnClickListener myhandler1 = new View.OnClickListener() {
        public void onClick(View v) {

            Toast.makeText(BindingActivity.this, "click", Toast.LENGTH_SHORT).show();

            if (mBound) {
                // Call a method from the LocalService.
                // However, if this call were something that might hang, then this request should
                // occur in a separate thread to avoid slowing down the activity performance.
                int num = mService.getRandomNumber();
                Toast.makeText(BindingActivity.this, "number: " + num, Toast.LENGTH_SHORT).show();


            }
        }
    };


        @Override
        protected void onStart() {
            super.onStart();
            // Bind to LocalService

            startService(new Intent(this, MonService.class));

            Intent intent = new Intent(BindingActivity.this, MonService.class);
            bindService(intent, mConnection, Context.BIND_AUTO_CREATE);
        }

        @Override
        protected void onStop() {
            super.onStop();
            // Unbind from the service
            if (mBound) {
                unbindService(mConnection);
                mBound = false;
            }
        }


        public ServiceConnection mConnection = new ServiceConnection() {

            @Override
            public void onServiceConnected(ComponentName className,
                                           IBinder service) {
                // We've bound to LocalService, cast the IBinder and get LocalService instance
                MonService.LocalBinder binder = (MonService.LocalBinder) service;
                mService = binder.getService();
                mBound = true;


                Toast.makeText(BindingActivity.this, "BINDING OK: ", Toast.LENGTH_SHORT).show();

            }

            @Override
            public void onServiceDisconnected(ComponentName arg0) {
                mBound = false;
            }
        };


    }